import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class PhysArkitus extends PApplet {Renderer REND;
PhysWorld WORLD;
Stabilizer FRS;
Pointer DRAGGED;
MouseController MC;

// Polygon shapes
Point[] box;

// Various materials
Material alu;
Material wood;
Material fixed;
Material iron;
Material plastic;

// Physical objects
Pointer b0;
Pointer b1;
Pointer b2;
Pointer b4;
Pointer b5;
Pointer b6;
Pointer b7;
Pointer b8;

// Weld Points
Pointer w0b1;
Pointer w0b2;
Pointer w0b5;
Pointer w1b5;

public void setup()
{  
  size(800,420);
  smooth();

  box = new Point[4];
  box[0] = new Point(+1,-1);
  box[1] = new Point(+1,+1);
  box[2] = new Point(-1,+1);
  box[3] = new Point(-1,-1);
  
  FRS = new Stabilizer(2);
  REND = new Renderer();
  WORLD = new PhysWorld();
 
  //==================================
  // CHANGE THESE
  //==================================

  // Gravity
  WORLD.setGravity(9.81f,HALF_PI);

  // Various materials
  alu = new Material(300, 0.3f, 10, 0xffF1F1F1);
  wood = new Material(400, 0.1f, 15, 0xffCC9966);
  fixed = new Material(0, 0.9f, 10, 0xff000000);
  iron = new Material(1000, 0.3f, 9, 0xff999999);
  plastic = new Material(300, 0.2f, 8, 0xff94D6FC);

  // Physical objects
  b0 = WORLD.addObject(pix2met(400),pix2met(431),fixed,new Polygon(box).scale(pix2met(800),pix2met(25)));
  b1 = WORLD.addObject(pix2met(810),pix2met(0),fixed,new Polygon(box).scale(pix2met(18),pix2met(840)));
  b2 = WORLD.addObject(pix2met(-10),pix2met(0),fixed,new Polygon(box).scale(pix2met(17),pix2met(840)));
  b4 = WORLD.addObject(pix2met(500),pix2met(100),plastic,new Polygon(3).scale(pix2met(180),pix2met(120)));
  b5 = WORLD.addObject(pix2met(400),pix2met(200),iron,new Polygon(box).scale(pix2met(300),pix2met(30)));
  b6 = WORLD.addObject(pix2met(500),pix2met(100),alu,new Polygon(4).scale(pix2met(150),pix2met(100)));
  b7 = WORLD.addObject(pix2met(300),pix2met(100),wood,new Polygon(4).scale(pix2met(150),pix2met(148)));
  b8 = WORLD.addObject(pix2met(400),pix2met(-10),fixed,new Polygon(box).scale(pix2met(800),pix2met(17)));

  // Weld Points
  w0b1 = WORLD.addWeldPoint(b1,new Point(pix2met(-50),pix2met(+50)));
  w0b2 = WORLD.addWeldPoint(b2,new Point(pix2met(+50),pix2met(+50)));
  w0b5 = WORLD.addWeldPoint(b5,new Point(pix2met(+130),pix2met(0)));
  w1b5 = WORLD.addWeldPoint(b5,new Point(pix2met(-130),pix2met(0)));

  // Links
  WORLD.addLink(b1,w0b1,b5,w0b5,pix2met(280),35000);
  WORLD.addLink(b2,w0b2,b5,w1b5,pix2met(280),35000);

  //==================================
  // STOP CHANGING! ;)
  //==================================
  
  MC = new MouseController();
}

public void draw()
{
  REND.drawFrame();
  WORLD.update();
  FRS.update(framerate);
}

public float pix2met(float Pixels)
{
  return Pixels/51;
}

public float met2pix(float Meters)
{
  return Meters*51;
}

public void mousePressed()
{
  MC.pressed();
}

public void mouseDragged()
{
  MC.dragged();
}

public void mouseReleased()
{
  MC.released();
}

class Force
{
  Point point;
  Vector force;
  
  Force()
  {
    point = new Point();
    force = new Vector();
  }
}

class Interval
{
  float min;
  float max;
  
  Interval(float Min, float Max)
  {
    min = Min;
    max = Max;
  }
  
  public void insert(float value)
  {
    if (value > max)
    {
      max = value;
    }
    else if (value < min)
    {
      min = value;
    }
  }
  
  public Interval offset(float k)
  {
    Interval R = new Interval(0,0);
    R.min = min+k;
    R.max = max+k;
    return R;
  }
  
  public Interval intersect(Interval I)
  {
    Interval R;
    
    if ((min <= I.max && min >= I.min) || (I.min <= max && I.min >= min))
    {
      if ( min > I.min )
      {
        R = new Interval(min,I.max);
      }
      else
      {
        R = new Interval(I.min,max);
      }
    }
    else
    {
      R = new Interval(0,0);
    }
    
    return R;
  }
  
  public float length()
  {
    return max-min;
  }
}

class Material
{
  float invDensity;
  float bounce;
  float frictionK;
  int c;
  
  Material(float density, float Bounce, float FrictionK, int C)
  {
    if ( density == 0 )
    {
      invDensity = 0;
    }
    else
    {
      invDensity = 1/density;
    }
    
    frictionK = FrictionK;
    bounce = Bounce;
    c = C;
  }
}

class MouseController
{
  Pointer mouse;
  Pointer mouseWeld;
  Pointer object;
  Pointer objectWeld;
  
  MouseController()
  {
    mouse = WORLD.addObject(pix2met(-10),pix2met(-10),fixed,new Polygon(4).scale(pix2met(1),pix2met(1)));
    mouseWeld = WORLD.addWeldPoint(mouse,new Point(0,0));
    WORLD.addColBlackList(mouse, new Pointer(-1));
  }
  
  public void pressed()
  {
    WORLD.setPosition(mouse, new Point(pix2met(mouseX), pix2met(mouseY)));
    object = WORLD.getObjAt(new Point(pix2met(mouseX), pix2met(mouseY)));
    
    if (object.index != -1)
    {
      objectWeld = WORLD.addWeldPoint(object,new Point(pix2met(mouseX)-WORLD.objects[object.index].center.x,pix2met(mouseY)-WORLD.objects[object.index].center.y));

      WORLD.addLink(mouse,mouseWeld,object,objectWeld,pix2met(50),50000);
    }
  }
  
  public void dragged()
  {
    if (object.index != -1)
    {
      WORLD.setPosition(mouse, new Point(pix2met(mouseX), pix2met(mouseY)));
    }
  }
  
  public void released()
  {
    WORLD.setPosition(mouse, new Point(pix2met(-10), pix2met(-10)));
    if (object.index != -1)
    {
      WORLD.popLink();
      WORLD.popWeld(object);
    }
  }
}

class PhysLink
{
  Pointer A;
  Pointer B;
  Pointer AWeld;
  Pointer BWeld;
  
  Point AW;
  Point BW;
  
  float len;
  float invK;
  
  PhysLink(Pointer a, Pointer b, Pointer aWeld, Pointer bWeld, float Len, float K)
  {
    A = a;
    B = b;
    AWeld = aWeld;
    BWeld = bWeld;
    
    AW = new Point();
    BW = new Point();
    
    len = Len;
    
    if (K != 0)
    {
      invK = 1/K;
    }
    else
    {
      invK = 0;
    }
  }
  
  PhysLink()
  {
  }
  
  public void update()
  {
    Vector rA = new Vector(WORLD.objects[A.index].weldPoints[AWeld.index]);
    Vector rB = new Vector(WORLD.objects[B.index].weldPoints[BWeld.index]);
 
    AW = WORLD.objects[A.index].center.addVector(rA);
    BW = WORLD.objects[B.index].center.addVector(rB);
    
    float delta_x = BW.x - AW.x;
    float delta_y = BW.y - AW.y;
    float delta_d = sqrt(pow(delta_x,2)+pow(delta_y,2));
    float dir = atan2(delta_y,delta_x);
    float delta_l = delta_d-len;

    if (invK != 0 || abs(delta_l) > 1)
    {
      Vector force = new Vector();
      force.dir = dir;
      if (invK != 0)
      {
        force.len = delta_l/invK;
      }
      else
      {
        force.len = delta_l*1E5f;
      }
      
      if ( delta_l > 0 )
      {
        WORLD.objects[A.index].addForce(WORLD.objects[A.index].weldPoints[AWeld.index], force.multiply(+1));
        WORLD.objects[B.index].addForce(WORLD.objects[B.index].weldPoints[BWeld.index], force.multiply(-1));
      }
    }
    else
    {
      Vector vA = WORLD.objects[A.index].veloc;
      Vector vB = WORLD.objects[B.index].veloc;
      Vector vAB = vA.addVector(vB.multiply(-1));
      
      Vector MTD = new Vector();
      MTD.dir = dir;
      MTD.len = delta_l;

      if (MTD.len != 0)
      {      
        float invMassA = WORLD.objects[A.index].material.invDensity/WORLD.objects[A.index].poly.area;
        float invMassB = WORLD.objects[B.index].material.invDensity/WORLD.objects[B.index].poly.area;
        float j = (-1.5f*vAB.dot(MTD))/(MTD.dot(MTD)*(invMassA+invMassB)+pow(rA.normal().dot(MTD),2)*WORLD.objects[A.index].invMomentOfInertia+pow(rB.normal().dot(MTD),2)*WORLD.objects[B.index].invMomentOfInertia);
        
        if (invMassA != 0) WORLD.objects[A.index].impulse(MTD,+invMassA/(invMassA+invMassB),+j,rA);
        if (invMassB != 0) WORLD.objects[B.index].impulse(MTD,-invMassB/(invMassA+invMassB),-j,rB);
      }
    }
    
    WORLD.objects[A.index].rotationSpeed *= 0.99f;
    WORLD.objects[A.index].veloc.len *= 0.99f;    
    WORLD.objects[B.index].rotationSpeed *= 0.99f;
    WORLD.objects[B.index].veloc.len *= 0.99f;    
  }
}

class PhysObject
{
  Polygon poly;
  Material material;
  
  Force[] forces;
  Vector accel;
  Vector veloc;
  Point center;
  
  float torque;
  float invMomentOfInertia;
  float rotationSpeed;
  
  Point[] weldPoints;

  PhysObject()
  {
    forces = new Force[5];
    for (int i=0; i<forces.length; i++) forces[i] = new Force();
    
    weldPoints = new Point[10];
    for (int i=0; i<weldPoints.length; i++) weldPoints[i] = new Point(-1.0f,-1.0f);
    
    accel = new Vector();
    veloc = new Vector();
    rotationSpeed = 0;
    invMomentOfInertia = 1;
  }

  public void update(Vector gravity, float delta_t)
  {
    fall(gravity);
    move(delta_t);
  }

  public void reset()
  {
    for (int i=0; i<forces.length; i++)
    {
      forces[i] = new Force();
    }
    
    accel = new Vector();
    torque = 0;
  }

  public void fall(Vector gravity)
  {
    if ( material.invDensity != 0 )
    {
      float mass = poly.area/material.invDensity;
      addForce(new Point(0,0), gravity.multiply(mass));
    }
  }

  public void move(float delta_t)
  {
    Vector totalForceVector = new Vector();   
    for (int i=0; i<forces.length; i++)
    {
      totalForceVector = totalForceVector.addVector(forces[i].force);
    }

    float mass = poly.area/material.invDensity;
    accel = totalForceVector.multiply(1/mass);
    center = center.addVector(veloc.multiply(delta_t)).addVector(accel.multiply(pow(delta_t,2)/2));
    veloc = veloc.addVector(accel.multiply(delta_t));    
    
    for (int i=0; i<forces.length; i++)
    {
      Vector r = new Vector(forces[i].point);
      float perpDot = forces[i].force.normal().dot(r);
      torque += perpDot;
    }
    
    torque *= invMomentOfInertia;

    poly.rotatePoly(rotationSpeed*delta_t+torque*(pow(delta_t,2)/2));
    rotateWeldPoints(rotationSpeed*delta_t+torque*(pow(delta_t,2)/2));
    rotationSpeed += torque*delta_t;
    
    // Hack to reduce spinning - does the job of air friction
    rotationSpeed *= 0.99f;
    // End hack
  }
  
  public void rotateWeldPoints(float r)
  {
    for (int i=0; i<weldPoints.length; i++)
    {
      if ( weldPoints[i].x != -1 || weldPoints[i].y != -1 )
      {
        weldPoints[i] = weldPoints[i].rotatePoint(r);
      }
    }
  }

  public void impulse(Vector v, float k, float j, Vector r)
  { 
    float invMass = material.invDensity/poly.area;
    
    center = center.addVector(v.multiply(k));
    veloc = veloc.addVector(v.multiply(j*invMass));
    rotationSpeed -= v.multiply(j).dot(r.normal())*invMomentOfInertia;
  }
  
  public void addForce(Point P, Vector V)
  {
    for (int i=0; i<forces.length; i++)
    {
      if ( forces[i].force.len == 0 )
      {
        forces[i] = new Force();
        forces[i].point = P;
        forces[i].force = V;
        break;
      }
    }
  }
  
  public void calculateMoment()
  {
    invMomentOfInertia = 0;
    
    if ( material.invDensity != 0 )
    {
      float R = 0;
      
      for (int i=0; i<poly.vertices.length; i++)
      {
        Vector Pn;
        Vector Pnp1;
        
        if (i<poly.vertices.length-1)
        {
          Pn = new Vector(poly.vertices[i]);
          Pnp1 = new Vector(poly.vertices[i+1]);
        }
        else
        {
          Pn = new Vector(poly.vertices[i]);
          Pnp1 = new Vector(poly.vertices[0]);
        }
        
        R += (abs(Pn.dot(Pnp1.normal()))*(Pn.dot(Pn)+Pnp1.dot(Pnp1)+Pn.dot(Pnp1)));
      }
      
      invMomentOfInertia = 1/(R/material.invDensity/12);
    }
  }
  
  public boolean inObj(Point p)
  {
    float x_rel = p.x - center.x;
    float y_rel = p.y - center.y;
    
    return poly.inPoly(new Point(x_rel, y_rel));
  }
}

class PhysWorld
{
  Vector gravity;
  int num_objects;
  PhysObject[] objects;
  int num_links;
  PhysLink[] links;
  int num_blacklist;
  Pointer[][] colBlackList;

  PhysWorld()
  {
    num_objects = 0;
    num_links = 0;
    num_blacklist = 0;
    gravity = new Vector();
    objects = new PhysObject[0];
    colBlackList = new Pointer[0][2];
  }

  //==================================
  // UPDATE PHYSICS WORLD
  //==================================

  public void update()
  {       
    float num_step = 4;
    
    if (millis() > 2000)
    {
      for (int k=0; k<num_step; k++)
      {
        float delta_t = 1/FRS.value()/num_step;
        
        for (int i=0; i<num_objects; i++)
        {
          objects[i].reset();     
        }
        
        for (int i=0; i<num_links; i++)
        {
          links[i].update();
        }
        
        for (int i=0; i<num_objects; i++)
        { 
          objects[i].update(gravity,delta_t);    
          for (int j=i+1; j<num_objects; j++)
          {            
            if (!blackListed(new Pointer(i),new Pointer(j)))
            {
              collide(objects[i], objects[j]);
            }
          }      
        }
      }
    }
  }

  //==================================
  // COLLISION DETECTION AND RESPONSE
  //==================================

  public void collide(PhysObject A, PhysObject B)
  {
    float delta_x = A.center.x - B.center.x;
    float delta_y = A.center.y - B.center.y;
    float delta_d = sqrt(pow(delta_x,2)+pow(delta_y,2));
    float sum_r = A.poly.radius + B.poly.radius;
            
    if ((A.material.invDensity != 0 || B.material.invDensity != 0) && delta_d <= sum_r)
    {
      Vector MTD = calculateMTD(A, B);
       
      if ( MTD.len != 0 )
      {
        Point[] contactPoints = findContactPoints(A,B,MTD);
        
        Vector vA = A.veloc;
        Vector vB = B.veloc;
        Vector vAB = vA.addVector(vB.multiply(-1));
        Vector rA = new Vector(contactPoints[0]);
        Vector rB = new Vector(contactPoints[1]);
        
        float e = A.material.bounce*B.material.bounce;
        float invMassA = A.material.invDensity/A.poly.area;
        float invMassB = B.material.invDensity/B.poly.area;
               
        Vector vtA = A.veloc.addVector(rA.multiply(A.rotationSpeed));
        Vector vtB = B.veloc.addVector(rB.multiply(B.rotationSpeed));
        Vector vtAB = vA.addVector(vB.multiply(-1));       

        float j = (-(1+e)*vAB.dot(MTD))/(MTD.dot(MTD)*(invMassA+invMassB)+pow(rA.normal().dot(MTD),2)*A.invMomentOfInertia+pow(rB.normal().dot(MTD),2)*B.invMomentOfInertia);
        
        if (invMassA != 0) A.impulse(MTD,+0.5f,+j,rA);
        if (invMassB != 0) B.impulse(MTD,-0.5f,-j,rB);
        
        float frictionK = A.material.frictionK*B.material.frictionK;
        Vector frictionV = new Vector();
        frictionV.dir = MTD.normal().dir;
        frictionV.len = vtAB.dot(MTD.normal())*frictionK*j;
        
        // Hack to prevent very large friction forces - Worst hack of them all
        if (abs(frictionV.len)>1E4f) frictionV.len *= 1E4f/abs(frictionV.len);
        // End hack
        
        if (vtAB.dot(MTD) <= 0)
        {
          A.addForce(rA.getCoords(), frictionV.multiply(-1));
          B.addForce(rB.getCoords(), frictionV.multiply(+1));         
        }
      }
    }
  }
  
  public Point[] findContactPoints(PhysObject A, PhysObject B, Vector MTD)
  {
    Point[] R = new Point[2];
    R[0] = new Point();
    R[1] = new Point();
    
    Point[] supportA = findSupportPoints(A.poly, MTD);
    Point[] supportB = findSupportPoints(B.poly, MTD.multiply(-1));

    int sNumA = numSupportPoints(supportA);
    int sNumB = numSupportPoints(supportB);

    if (sNumA == 1 && sNumB == 1)
    {
      R[0] = supportA[0];
      R[1] = supportB[0];
    }
    else if (sNumA == 1 && sNumB == 2)
    {
      R[0] = supportA[0];
      Vector edge = new Vector(supportB[1].x-supportB[0].x, supportB[1].y-supportB[0].y);
      R[1] = projectPointOnEdge(A.center.addVector(new Vector(supportA[0])), edge, B.center.addVector(new Vector(supportB[0]))).addVector(new Vector(B.center.multiply(-1)));
    }
    else if (sNumA == 2 && sNumB == 1)
    {
      R[1] = supportB[0];
      Vector edge = new Vector(supportA[1].x-supportA[0].x, supportA[1].y-supportA[0].y);
      R[0] = projectPointOnEdge(B.center.addVector(new Vector(supportB[0])), edge, A.center.addVector(new Vector(supportA[0]))).addVector(new Vector(A.center.multiply(-1)));
    }
    else if (sNumA == 2 && sNumB == 2)
    {
      // Hack to prevent objects from shaking on top of each other
      A.rotationSpeed = 0;
      B.rotationSpeed = 0;
      // End hack
      
      Point[] sortedPoints = new Point[4];
      String[] sortedPointsType = new String[4];
      
      sortedPoints[0] = supportA[0];
      sortedPoints[1] = supportA[1];
      sortedPoints[2] = supportB[0];
      sortedPoints[3] = supportB[1];
      
      sortedPointsType[0] = "A";
      sortedPointsType[1] = "A";
      sortedPointsType[2] = "B";
      sortedPointsType[3] = "B";
      
      Vector normalMTD = MTD.normal();
      
      for (int i=3; i>=0; i--)
      {
        for (int j=0; j<=i-1; j++)
        {
          Point centerJ = new Point();
          Point centerJPlus1 = new Point();
          
          if ( sortedPointsType[j] == "A" ) 
          {
            centerJ = A.center;
          } else {
            centerJ = B.center; 
          }
          if ( sortedPointsType[j+1] == "A" ) {
            centerJPlus1 = A.center;
          } else {
            centerJPlus1 = B.center; 
          }
          
          float dotJ = normalMTD.dot(new Vector(sortedPoints[j])) + normalMTD.dot(new Vector(centerJ));
          float dotJPlus1 = normalMTD.dot(new Vector(sortedPoints[j+1])) + normalMTD.dot(new Vector(centerJPlus1));
          
          if ( dotJ > dotJPlus1 )
          {
            Point T1 = sortedPoints[j];
            sortedPoints[j] = sortedPoints[j+1];
            sortedPoints[j+1] = T1;
            
            String T2 = sortedPointsType[j];
            sortedPointsType[j] = sortedPointsType[j+1];
            sortedPointsType[j+1] = T2;
          }
        }
      }
      
      if ( sortedPointsType[1] == "B" && sortedPointsType[2] == "A" )
      {
        R[0] = projectPointOnEdge(B.center.addVector(new Vector(sortedPoints[1])), normalMTD, A.center.addVector(new Vector(sortedPoints[2]))).addVector(new Vector(A.center.multiply(-1)));
        R[1] = projectPointOnEdge(A.center.addVector(new Vector(sortedPoints[2])), normalMTD, B.center.addVector(new Vector(sortedPoints[1]))).addVector(new Vector(B.center.multiply(-1)));
      }
      else if ( sortedPointsType[1] == "A" && sortedPointsType[2] == "B" )
      {
        R[0] = projectPointOnEdge(B.center.addVector(new Vector(sortedPoints[2])), normalMTD, A.center.addVector(new Vector(sortedPoints[1]))).addVector(new Vector(A.center.multiply(-1)));
        R[1] = projectPointOnEdge(A.center.addVector(new Vector(sortedPoints[1])), normalMTD, B.center.addVector(new Vector(sortedPoints[2]))).addVector(new Vector(B.center.multiply(-1)));
      }
      else if ( sortedPointsType[1] == "A" && sortedPointsType[2] == "A" )
      {
        Point middlePoint = sortedPoints[1].addVector(new Vector(sortedPoints[2])).multiply(0.5f);
        R[0] = middlePoint;
        R[1] = projectPointOnEdge(A.center.addVector(new Vector(middlePoint)), normalMTD, B.center.addVector(new Vector(supportB[0]))).addVector(new Vector(B.center.multiply(-1)));
      }
      else if ( sortedPointsType[1] == "B" && sortedPointsType[2] == "B" )
      {
        Point middlePoint = sortedPoints[1].addVector(new Vector(sortedPoints[2])).multiply(0.5f);
        R[0] = projectPointOnEdge(B.center.addVector(new Vector(middlePoint)), normalMTD, A.center.addVector(new Vector(supportA[0]))).addVector(new Vector(A.center.multiply(-1)));
        R[1] = middlePoint;        
      }
    }
    
    return R;
  }
   
  public Point[] findSupportPoints(Polygon P, Vector V)
  {
    Point supportPoints[] = new Point[2];
    supportPoints[0] = P.vertices[0];
    supportPoints[1] = new Point(0,0);
    float minimumDot = new Vector(P.vertices[0]).dot(V);
    float[] dot = new float[P.vertices.length];
    dot[0] = minimumDot;
    
    for (int i=1; i<P.vertices.length; i++)
    {
      dot[i] = new Vector(P.vertices[i]).dot(V);
      if (dot[i] < minimumDot)
      {
        minimumDot = dot[i];
      }
    }

    final float threshold = 1E-6f;
    int index = 0;
    
    for (int i=0; i<P.vertices.length; i++)
    {
      if (dot[i]-minimumDot < threshold)
      {
        supportPoints[index++] = P.vertices[i];
        if (index==2) break;
      }
    }

    return supportPoints;
  }
  
  public int numSupportPoints(Point[] support)
  {
    int R = 1;
    if ( support[1].x != 0 || support[1].y != 0 ) R++;
    return R;
  }
  
  public Point projectPointOnEdge(Point P, Vector V, Point offsetV)
  {
    Point R = new Point();
    
    Vector vectorP = new Vector(P);
    Vector vectorR = new Vector();
    vectorP = vectorP.addVector(new Vector(offsetV).multiply(-1));
    vectorR.dir = V.dir;
    vectorR.len = V.dot(vectorP)/V.len;
    R = vectorR.addVector(new Vector(offsetV)).getCoords();
    
    return R;
  }
  
  public Vector calculateMTD(PhysObject A, PhysObject B)
  {
    int index = 0;
    Vector[] pushVectors = new Vector[A.poly.numEdges()+B.poly.numEdges()];

    for (int i = 0; i<A.poly.numEdges(); i++)
    {
      float intervalIntersection = calculateIntervalIntersection(A.poly.getEdge(i).normal(), A, B);
      if (intervalIntersection == 0)
      {
        return new Vector();
      }
      pushVectors[index] = new Vector();
      pushVectors[index].len = intervalIntersection;
      pushVectors[index].dir = A.poly.getEdge(i).normal().dir;
      index++;
    } 
    for (int i = 0; i<B.poly.numEdges(); i++)
    {       
      float intervalIntersection = calculateIntervalIntersection(B.poly.getEdge(i).normal(), A, B);
      if (intervalIntersection == 0)
      {
        return new Vector();
      }
      pushVectors[index] = new Vector();
      pushVectors[index].len = intervalIntersection;
      pushVectors[index].dir = B.poly.getEdge(i).normal().dir;
      index++;
    }

    Vector currentBest = new Vector();

    for (int i=0; i<pushVectors.length; i++)
    {
      if (( pushVectors[i].len < currentBest.len && pushVectors[i].len != 0 ) || currentBest.len == 0 )
      {
        currentBest = pushVectors[i];
      }
    }

    Vector D = new Vector(A.center.addVector(new Vector(B.center.multiply(-1)))); 
    if (D.dot(currentBest) < 0)
    { 
      currentBest = currentBest.multiply(-1); 
    }

    return currentBest; 
  }

  public float calculateIntervalIntersection(Vector N, PhysObject A, PhysObject B)
  {
    Interval intervalA = calculateInterval(N,A).offset(new Vector(A.center.x,A.center.y).dot(N)/N.len);
    Interval intervalB = calculateInterval(N,B).offset(new Vector(B.center.x,B.center.y).dot(N)/N.len);
    Interval intersection = intervalA.intersect(intervalB);            
    return intersection.length();
  }

  public Interval calculateInterval(Vector axis, PhysObject O)
  { 
    Interval R = new Interval(0,0);
    for (int i=0; i<O.poly.numEdges(); i++)
    {
      R.insert((O.poly.getEdge(i).dot(axis) + new Vector(O.poly.getEdgeStart(i)).dot(axis))/axis.len);
    }
    return R;
  } 

  //==================================
  // INTERFACE
  //==================================

  public void setGravity(float len, float dir)
  {
    gravity.len = len;
    gravity.dir = dir;
  }

  public Pointer addObject(float x, float y, Material m, Polygon p)
  {
    num_objects++;
    PhysObject[] temp = new PhysObject[num_objects];

    for (int i=0; i<num_objects-1; i++)
    {
      temp[i] = objects[i];
    }

    temp[num_objects-1] = new PhysObject();
    temp[num_objects-1].center = new Point(x,y);
    temp[num_objects-1].material = m;
    temp[num_objects-1].poly = p;
    temp[num_objects-1].calculateMoment();
    objects = temp;

    return new Pointer(num_objects-1);
  }
  
  public void addLink(Pointer A, Pointer AWeld, Pointer B, Pointer BWeld, float len, float k)
  {
    num_links++;
    PhysLink[] temp = new PhysLink[num_links];

    for (int i=0; i<num_links-1; i++)
    {
      temp[i] = links[i];
    }

    temp[num_links-1] = new PhysLink(A, B, AWeld, BWeld, len, k);
    links = temp;
  }
  
  public void popLink()
  {
    num_links--;
    PhysLink[] temp = new PhysLink[num_links];

    for (int i=0; i<num_links; i++)
    {
      temp[i] = links[i];
    }

    links = temp;
  }

  public Pointer addWeldPoint(Pointer o, Point p)
  {
    for (int i=0; i<objects[o.index].weldPoints.length; i++)
    {
      if ( objects[o.index].weldPoints[i].x == -1.0f && objects[o.index].weldPoints[i].y == -1.0f )
      {
        objects[o.index].weldPoints[i] = p;
        return new Pointer(i);
      }
    }
    
    return new Pointer(objects[o.index].weldPoints.length);
  }
  
  public void popWeld(Pointer o)
  {
    for (int i=objects[o.index].weldPoints.length-1; i>=0; i--)
    {
      if ( objects[o.index].weldPoints[i].x != -1.0f && objects[o.index].weldPoints[i].y != -1.0f )
      {
        objects[o.index].weldPoints[i] = new Point(-1,-1);
        break;
      }
    }
  }

  public void setRotationSpeed(Pointer o, float w)
  {
    objects[o.index].rotationSpeed = w;
  }

  public void setRotation(Pointer o, float r)
  {
    objects[o.index].poly.rotatePoly(r);
  }
  
  public void setPosition(Pointer o, Point p)
  {
    objects[o.index].center = p;
    objects[o.index].veloc.len = 0;
    objects[o.index].rotationSpeed = 0;
  }
  
  public void addColBlackList(Pointer p1, Pointer p2)
  {
    num_blacklist++;
    Pointer[][] temp = new Pointer[num_blacklist][2];

    for (int i=0; i<num_blacklist-1; i++)
    {
      temp[i] = colBlackList[i];
    }

    temp[num_blacklist-1][0] = p1;
    temp[num_blacklist-1][1] = p2;
    colBlackList = temp;
  }
  
  public boolean blackListed(Pointer p1, Pointer p2)
  {
    for (int i=0; i<num_blacklist; i++)
    {
      if ((colBlackList[i][0].index == p1.index && colBlackList[i][1].index == p2.index) || (colBlackList[i][0].index == p2.index && colBlackList[i][1].index == p1.index) || 
          (colBlackList[i][0].index == p1.index && colBlackList[i][1].index == -1) || (colBlackList[i][0].index == p2.index && colBlackList[i][1].index == -1))
      {
        return true;
      }
    }
    
    return false;
  }
  
  public Pointer getObjAt(Point p)
  {
    for (int i=0; i<num_objects; i++)
    {
      if (objects[i].inObj(p))
      {
        return new Pointer(i);
      }
    }
    
    return new Pointer(-1);
  }
}

class Point
{
  float x;
  float y;
  
  Point()
  {
    x = 0;
    y = 0;
  }
  
  Point(float X, float Y)
  {
    x = X;
    y = Y;
  }
  
  public Point addVector(Vector V)
  {    
    Point R = new Point();
    R.x = x+V.getCoords().x;
    R.y = y+V.getCoords().y;
    return R;
  }
  
  public Point multiply(float k)
  {
    Point R = new Point();
    R.x = x*k;
    R.y = y*k;
    return R;
  }
  
  public Point multiply(float k, float j)
  {
    Point R = new Point();
    R.x = x*k;
    R.y = y*j;
    return R;
  }
  
  public Point rotatePoint(float r)
  {
    Point R = new Point();
    float xprev = x;
    float yprev = y;
    
    R.x = cos(r)*xprev+sin(r)*yprev;
    R.y = -sin(r)*xprev+cos(r)*yprev;
    return R;
  }
}

class Pointer
{
  int index;
  
  Pointer(int i)
  {
    index = i;
  }
}

class Polygon
{
  float radius;
  float area;
  Point[] vertices;

  Polygon(Point[] Vertices)
  {
    vertices = new Point[Vertices.length];
    for (int i=0; i<Vertices.length; i++) setVertex(i, Vertices[i]);
    radius = calculateRadius();
    area = calculateArea();
    translateToCenter();
  }
  
  Polygon(int num_segments)
  {
    vertices = new Point[num_segments];
    for(int i=0; i<num_segments; i++)
    {
      setVertex(i, new Point(cos(i*TWO_PI/num_segments),sin(i*TWO_PI/num_segments)));
    }
    radius = calculateRadius();
    area = calculateArea();
  }
  
  public void setVertex(int i, Point vertex)
  {
    vertices[i] = vertex;
  }
  
  public int numEdges()
  {
    return vertices.length;
  }
  
  public Polygon scale(float w, float h)
  {
    Polygon R = new Polygon(vertices);
    for (int i=0; i<vertices.length; i++)
    {
      R.setVertex(i, vertices[i].multiply(w/2, h/2));
    }
    R.radius = R.calculateRadius();
    R.area = R.calculateArea();
    return R;
  }
  
  public void rotatePoly(float r)
  {    
    for (int i=0; i<vertices.length; i++)
    {
      setVertex(i, vertices[i].rotatePoint(r));
    }
  }
  
  public Vector getEdge(int index)
  {
    int nextIndex = index+1;
    
    if ( index == numEdges()-1 )
    {
      nextIndex = 0;
    }
    
    return new Vector(vertices[nextIndex].x-vertices[index].x,vertices[nextIndex].y-vertices[index].y);
  }
  
  public Point getEdgeStart(int index)
  {
    return vertices[index];
  }
  
  public float calculateArea()
  {
    float R = 0;
    for (int i=0; i<vertices.length; i++)
    {
      if (i < vertices.length-1)
      {
        R += (vertices[i].x*vertices[i+1].y-vertices[i+1].x*vertices[i].y)/2;
      }
      else
      {
        R += (vertices[i].x*vertices[0].y-vertices[0].x*vertices[i].y)/2;
      }
    }
    
    return abs(R);
  }
  
  public void translateToCenter()
  {
    Point centerOfMass = new Point();
    
    for (int i=0; i<vertices.length; i++)
    {
      if (i < vertices.length-1)
      {
        float common = (vertices[i].x*vertices[i+1].y-vertices[i+1].x*vertices[i].y)/6/area;
        centerOfMass.x += (vertices[i].x+vertices[i+1].x)*common;
        centerOfMass.y += (vertices[i].y+vertices[i+1].y)*common;
      }
      else
      {
        float common = (vertices[i].x*vertices[0].y-vertices[0].x*vertices[i].y)/6/area;
        centerOfMass.x += (vertices[i].x+vertices[0].x)*common;
        centerOfMass.y += (vertices[i].y+vertices[0].y)*common;
      }
    }
    
    for (int i=0; i<vertices.length; i++)
    {
      vertices[i] = vertices[i].addVector(new Vector(centerOfMass).multiply(-1));
    }
  }
  
  public float calculateRadius()
  {
    float R = 0;
    
    for (int i=0; i<vertices.length; i++)
    {
      float l = sqrt(pow(vertices[i].x,2)+pow(vertices[i].y,2));
      
      if (l >= R)
      {
        R = l;
      }
    }
    
    return R;
  }
  
  // Thanks to Seltar (seltar.wliia.org) and Philippe Reverdy
  public boolean inPoly(Point p)
  {
    float R=0;
    
    for (int i=0; i<vertices.length; i++) 
    {
      float p1x = vertices[i].x - p.x;
      float p1y = vertices[i].y - p.y;
      float p2x = vertices[(i+1)%vertices.length].x - p.x;
      float p2y = vertices[(i+1)%vertices.length].y - p.y;
      
      R += angle2D(new Point(p1x,p1y),new Point(p2x,p2y));
    }

    if (abs(R) < PI)
      return false;
    else
      return true;
  }

  // Thanks to Seltar (seltar.wliia.org) and Philippe Reverdy
  public float angle2D(Point p1, Point p2)
  {
    float theta1 = atan2(p1.y,p1.x);
    float theta2 = atan2(p2.y,p2.x);
    float dtheta = theta2 - theta1;
    
    while (dtheta > PI)
      dtheta -= TWO_PI;
    while (dtheta < -PI)
      dtheta += TWO_PI;

    return dtheta;
  }
}

class Renderer
{
  public void drawFrame()
  {
    background(255,255,255);
    
    if (millis() > 2000)
    {
      for (int i=1; i<WORLD.num_objects; i++)
      {
        drawObject(WORLD.objects[i]);
      }
      
      for (int i=0; i<WORLD.num_links; i++)
      {
        drawLink(WORLD.links[i]);
      }
    
      for (int i=0; i<WORLD.num_objects; i++)
      {
        drawWeldPoints(WORLD.objects[i]);
      }
    }
  }
  
  public void drawObject(PhysObject object)
  {
    stroke(0xff000000);
    strokeWeight(2);
    fill(object.material.c);
    
    beginShape(POLYGON);
    for (int i=0; i<object.poly.vertices.length; i++)
    {
      vertex(met2pix(object.center.x+object.poly.vertices[i].x),met2pix(object.center.y+object.poly.vertices[i].y));
    }
    endShape();
  }
  
  public void drawWeldPoints(PhysObject object)
  {
    stroke(0xff6B6B6B);
    strokeWeight(2);
    fill(0xffFFFFFF);
    
    for (int i=0; i<object.weldPoints.length; i++)
    {
      if ( object.weldPoints[i].x != -1 && object.weldPoints[i].y != -1 )
      {
        ellipse(met2pix(object.center.x+object.weldPoints[i].x),met2pix(object.center.y+object.weldPoints[i].y),5,5);
      }
    }
  }
  
  public void drawLink(PhysLink link)
  {
    stroke(0,0,0,100);
    strokeWeight(3);
    line(met2pix(link.AW.x), met2pix(link.AW.y), met2pix(link.BW.x), met2pix(link.BW.y));
  }
}

class Stabilizer
{
  float[] array;
  
  Stabilizer(int PoolLength)
  {
    array = new float[PoolLength];
    for (int i=0; i<array.length; i++)
    {
      array[i] = 0;
    }
  }
  
  public void update(float value)
  {
    array = pushUp();
    array[0] = value;
  }
  
  public float[] pushUp()
  {
    float[] R = new float[array.length];
    R[0] = 0;
    
    for(int i=1; i<array.length; i++)
    {
      R[i] = array[i-1];
    }
    
    return R;
  }
  
  public float value()
  {
    float total = 0;
    for (int i=0; i<array.length; i++)
    {
      total += array[i];
    }
    return total/array.length;
  }
}

class Vector
{
  float len;
  float dir;
  
  Vector()
  {
    len = 0;
    dir = 0;
  }
  
  Vector(float x, float y)
  {
    setVector(x,y);
  }
  
  Vector(Point P)
  {
    setVector(P.x,P.y);
  }

  public Vector addVector(Vector V)
  {
    Vector R = new Vector();
    R.setVector(getCoords().x+V.getCoords().x,getCoords().y+V.getCoords().y);
    return R;
  }
  
  public Vector multiply(float k)
  {
    Vector R = new Vector();
    R.setVector(getCoords().x*k,getCoords().y*k);
    return R;
  }
  
  public Vector multiply(float k, float j)
  {
    Vector R = new Vector();
    R.setVector(getCoords().x*k,getCoords().y*j);
    return R;
  }
    
  public Point getCoords()
  {
    Point P = new Point();
    P.x = len*cos(dir);
    P.y = len*sin(dir);
    
    return P;
  }

  public void setVector(float delta_x, float delta_y)
  {
    len = sqrt(pow(delta_x,2)+pow(delta_y,2));
    dir = atan2(delta_y,delta_x);
  }
  
  public float dot(Vector v)
  {
    return getCoords().x*v.getCoords().x + getCoords().y*v.getCoords().y;
  }
  
  public Vector normal()
  {
    Vector R = new Vector(-getCoords().y, getCoords().x);
    return R;
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "PhysArkitus" });}}