class PhysLink
{
  Pointer A;
  Pointer B;
  Pointer AWeld;
  Pointer BWeld;
  
  Point AW;
  Point BW;
  
  float len;
  float invK;
  
  PhysLink(Pointer a, Pointer b, Pointer aWeld, Pointer bWeld, float Len, float K)
  {
    A = a;
    B = b;
    AWeld = aWeld;
    BWeld = bWeld;
    
    AW = new Point();
    BW = new Point();
    
    len = Len;
    
    if (K != 0)
    {
      invK = 1/K;
    }
    else
    {
      invK = 0;
    }
  }
  
  PhysLink()
  {
  }
  
  void update()
  {
    Vector rA = new Vector(WORLD.objects[A.index].weldPoints[AWeld.index]);
    Vector rB = new Vector(WORLD.objects[B.index].weldPoints[BWeld.index]);
 
    AW = WORLD.objects[A.index].center.addVector(rA);
    BW = WORLD.objects[B.index].center.addVector(rB);
    
    float delta_x = BW.x - AW.x;
    float delta_y = BW.y - AW.y;
    float delta_d = sqrt(pow(delta_x,2)+pow(delta_y,2));
    float dir = atan2(delta_y,delta_x);
    float delta_l = delta_d-len;

    if (invK != 0 || abs(delta_l) > 1)
    {
      Vector force = new Vector();
      force.dir = dir;
      if (invK != 0)
      {
        force.len = delta_l/invK;
      }
      else
      {
        force.len = delta_l*1E5;
      }
      
      if ( delta_l > 0 )
      {
        WORLD.objects[A.index].addForce(WORLD.objects[A.index].weldPoints[AWeld.index], force.multiply(+1));
        WORLD.objects[B.index].addForce(WORLD.objects[B.index].weldPoints[BWeld.index], force.multiply(-1));
      }
    }
    else
    {
      Vector vA = WORLD.objects[A.index].veloc;
      Vector vB = WORLD.objects[B.index].veloc;
      Vector vAB = vA.addVector(vB.multiply(-1));
      
      Vector MTD = new Vector();
      MTD.dir = dir;
      MTD.len = delta_l;

      if (MTD.len != 0)
      {      
        float invMassA = WORLD.objects[A.index].material.invDensity/WORLD.objects[A.index].poly.area;
        float invMassB = WORLD.objects[B.index].material.invDensity/WORLD.objects[B.index].poly.area;
        float j = (-1.5*vAB.dot(MTD))/(MTD.dot(MTD)*(invMassA+invMassB)+pow(rA.normal().dot(MTD),2)*WORLD.objects[A.index].invMomentOfInertia+pow(rB.normal().dot(MTD),2)*WORLD.objects[B.index].invMomentOfInertia);
        
        if (invMassA != 0) WORLD.objects[A.index].impulse(MTD,+invMassA/(invMassA+invMassB),+j,rA);
        if (invMassB != 0) WORLD.objects[B.index].impulse(MTD,-invMassB/(invMassA+invMassB),-j,rB);
      }
    }
    
    WORLD.objects[A.index].rotationSpeed *= 0.99;
    WORLD.objects[A.index].veloc.len *= 0.99;    
    WORLD.objects[B.index].rotationSpeed *= 0.99;
    WORLD.objects[B.index].veloc.len *= 0.99;    
  }
}
