class Renderer
{
  void drawFrame()
  {
    background(255,255,255);
    
    if (millis() > 2000)
    {
      for (int i=1; i<WORLD.num_objects; i++)
      {
        drawObject(WORLD.objects[i]);
      }
      
      for (int i=0; i<WORLD.num_links; i++)
      {
        drawLink(WORLD.links[i]);
      }
    
      for (int i=0; i<WORLD.num_objects; i++)
      {
        drawWeldPoints(WORLD.objects[i]);
      }
    }
  }
  
  void drawObject(PhysObject object)
  {
    stroke(#000000);
    strokeWeight(2);
    fill(object.material.c);
    
    beginShape(POLYGON);
    for (int i=0; i<object.poly.vertices.length; i++)
    {
      vertex(met2pix(object.center.x+object.poly.vertices[i].x),met2pix(object.center.y+object.poly.vertices[i].y));
    }
    endShape();
  }
  
  void drawWeldPoints(PhysObject object)
  {
    stroke(#6B6B6B);
    strokeWeight(2);
    fill(#FFFFFF);
    
    for (int i=0; i<object.weldPoints.length; i++)
    {
      if ( object.weldPoints[i].x != -1 && object.weldPoints[i].y != -1 )
      {
        ellipse(met2pix(object.center.x+object.weldPoints[i].x),met2pix(object.center.y+object.weldPoints[i].y),5,5);
      }
    }
  }
  
  void drawLink(PhysLink link)
  {
    stroke(0,0,0,100);
    strokeWeight(3);
    line(met2pix(link.AW.x), met2pix(link.AW.y), met2pix(link.BW.x), met2pix(link.BW.y));
  }
}
