class Vector
{
  float len;
  float dir;
  
  Vector()
  {
    len = 0;
    dir = 0;
  }
  
  Vector(float x, float y)
  {
    setVector(x,y);
  }
  
  Vector(Point P)
  {
    setVector(P.x,P.y);
  }

  Vector addVector(Vector V)
  {
    Vector R = new Vector();
    R.setVector(getCoords().x+V.getCoords().x,getCoords().y+V.getCoords().y);
    return R;
  }
  
  Vector multiply(float k)
  {
    Vector R = new Vector();
    R.setVector(getCoords().x*k,getCoords().y*k);
    return R;
  }
  
  Vector multiply(float k, float j)
  {
    Vector R = new Vector();
    R.setVector(getCoords().x*k,getCoords().y*j);
    return R;
  }
    
  Point getCoords()
  {
    Point P = new Point();
    P.x = len*cos(dir);
    P.y = len*sin(dir);
    
    return P;
  }

  void setVector(float delta_x, float delta_y)
  {
    len = sqrt(pow(delta_x,2)+pow(delta_y,2));
    dir = atan2(delta_y,delta_x);
  }
  
  float dot(Vector v)
  {
    return getCoords().x*v.getCoords().x + getCoords().y*v.getCoords().y;
  }
  
  Vector normal()
  {
    Vector R = new Vector(-getCoords().y, getCoords().x);
    return R;
  }
}
